/********************************************************************************
  * @file    KB_4x4.c																														*
  * @author  PLUM, Maciej Szumski																								*
  * @version V1.0																																*
  * @date    12-February-2016																										*
  * @brief   This file contains all functions for the KAmodKB4x4								*
  *******************************************************************************/
#include ".\..\Drivers\KAmodKB4x4\KB_4x4.h"

const unsigned char KBkody[] = {'/','*','-','+',0x0D,'9','6','3','0','8','5','2','.','7','4','1'};

// odczytuje stan klawiszy: identyfikuje wcisniety, zwraca kod ASCII ------------
char KB2char(void){
	unsigned int GPIO_Pin_row, GPIO_Pin_col, i, j;
	GPIO_SetBits(GPIOD, GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13);
	GPIO_Pin_row = GPIO_Pin_10;
	for(i=0; i<4; i++){
		GPIO_ResetBits(GPIOD, GPIO_Pin_row);
		delay_us(32800); 		// 4.1 ms czas na ustalenie poziomow sygnalow
		GPIO_Pin_col = GPIO_Pin_6;
		for(j=0; j<4; j++){
			if(GPIO_ReadInputDataBit(GPIOD, GPIO_Pin_col) == 0) {
				GPIO_ResetBits(GPIOD, GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13);
				return KBkody[4*i+j];
			}
			GPIO_Pin_col = GPIO_Pin_col << 1;
		}
		GPIO_SetBits(GPIOD, GPIO_Pin_row);
		GPIO_Pin_row = GPIO_Pin_row << 1;
	}
	GPIO_ResetBits(GPIOD, GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13);
	return 0;
}
// pobiera znak z bufora 'key_buffer', dosuwa znaki i wpisuje NUL na koncu ------------
// wysyla echo na wyswietlacz
unsigned char get_char(void){
	int i;
	unsigned char c;
	while (key_buffer[0] == 0) // czekamy na klawisz
		;
	c = key_buffer[0];
	
	NVIC_DisableIRQ(EXTI9_5_IRQn);	// zabrania na przerwania EXTI od klawiszy
	for(i=0; i<31; i++)
		key_buffer[i] = key_buffer[i+1];
	key_pointer--;
	key_buffer[31]=0;
	NVIC_EnableIRQ(EXTI9_5_IRQn);		// zezwala na przerwania EXTI od klawiszy
	if(c != 0x0D)
		LCD_WriteCharacter(c); // echo
	return c;
}

// pobiera znaki i wpisuje do bufora 'KB2mem' -----------------------------------
void get_str(void){
	int i;
	unsigned char c;
	
	for(i=0; i<32; i++)
		KB2mem[i] = ' ';
	for(i=0; i<32; i++){
		c = get_char();
		if(c == 0x0D)
			break;
		else 
			KB2mem[i] = c;
	}
}
// wyswietla komunikat, pobiera znaki i wpisuje do bufora 'KB2mem' --------------
void LCD_getString(unsigned char * text) {
  LCD_WriteText((unsigned char *) text);
	get_str();
}

/**************** (C) COPYRIGHT 2016 PLUMicroelectronics *******END OF FILE******/	



